#include "TI-85.h"
#include "Peak1.h"

BLOCKSIZE       =1024
BLOCKBUFFER     =VIDEO_MEM
BLOCKBUFFERTOP  =$FFFF


.org $8BF9

CustomData:
.db     $04

MenuJump:
        jp Start

MenuText:
.db     "Peak",0

AutoRun:
.db     7,"AutoRun",0

Start:
        CURSOR_OFF
        PB_ON_W
        PNO_SCROLL
        PNO_AFFECT_TEXT
        BBUSY_OFF

        ld HL,(CURSOR_ROW)
        push HL

LoadMenu:
        ld HL,AutoRun-1
        call RunProgram

Exit:
        pop HL
        ld (CURSOR_ROW),HL

        CURSOR_ON
        PB_ON_W
        PAFFECT_TEXT

        jp HOME_SCREEN

Undefined:
        pop HL
        ld A,14
        jp D_ERROR

RunProgram:
        GET_VAR
        jr C,Undefined
        ld (VarAddress),DE
        ld (VarAddress2),DE
;        ld (VATAddress),HL              ;uncomment if you need this

        ex DE,HL

        ld DE,RelocationArea
        ld (DEST),DE

        ld C,(HL)
        inc HL
        ld B,(HL)
        inc HL

        push BC

LoopBack:
        ld (VarLength),BC
        ld (BlockLength),BC

        push HL
        push DE

        ld H,B
        ld L,C

        ld DE,BLOCKSIZE

        ex DE,HL

        call CP_HL_DE
        jr NC,UnderSize

        ld BC,BLOCKSIZE
        ld (VarLength),BC

UnderSize:
        pop DE
        pop HL

        ld DE,BLOCKBUFFER
        ld BC,(VarLength)
        ldir

        dec HL
        ex DE,HL

        push DE
        ld HL,(VarAddress)
        inc HL

        push HL
        ld DE,(DEST)

        or A
        sbc HL,DE

        ld B,H
        ld C,L
        pop HL
        pop DE

        inc BC
        ld (MoveSize),BC
        lddr

        ld HL,BLOCKBUFFER
        ld DE,(DEST)
        ld BC,(VarLength)
        ldir

TestBlockSize:
        ld HL,BLOCKSIZE
        ld DE,(BlockLength)
        call CP_HL_DE
        jr NC,UnderSize2

        ld DE,BLOCKSIZE
        ld HL,(BlockLength)
        or A
        sbc HL,DE
        push HL
        ex DE,HL

        ld BC,BLOCKSIZE

        ld HL,(DEST)
        add HL,BC
        ld (DEST),HL

        ld HL,(VarAddress)
        add HL,BC
        ld (VarAddress),HL

        pop BC
        ld (HL),C
        inc HL
        ld (HL),B
        inc HL

        jr LoopBack

UnderSize2:
        ld HL,(VarAddress)
        ld DE,(BlockLength)
        add HL,DE
        ld (VarAddress),HL

        xor A

        ld (HL),A
        inc HL
        ld (HL),A

        ld HL,($8BF7)
        add HL,BC
        ld ($8BF7),HL

        pop BC
        push BC

        call AVATFix

RExecute:
        call RelocationArea

        pop BC
        ld (BlockLength),BC

        ld HL,(VarAddress2)
        add HL,BC

        ld (HL),C
        inc HL
        ld (HL),B
        ld (VarAddress),HL

        call SVATFix


Delocate:
        ld HL,BLOCKSIZE
        ld DE,(BlockLength)
        ld (VarLength),DE
        call CP_HL_DE
        jr NC,UnderSize3

        ld (VarLength),HL

UnderSize3:
        ld HL,RelocationArea-1
        ld DE,(BlockLength)
        add HL,DE
        ld DE,BLOCKBUFFERTOP
        ld BC,(VarLength)
        lddr                    ;Copy out

        ex DE,HL

        push DE
        ld HL,RelocationArea
        ld DE,(BlockLength)
        add HL,DE
        pop DE
        inc DE
        ld BC,(MoveSize)
        ldir                    ;Move it all down

        ld HL,BLOCKBUFFERTOP
        ld DE,(VarAddress)
        ld BC,(VarLength)
        lddr
        ld (VarAddress),DE     ;copy it back in

        ld HL,(BlockLength)
        ld DE,(VarLength)
        or A
        sbc HL,DE
        ret Z
        ld (BlockLength),HL     ;Set new length

        jr Delocate

AVATFix:			;input: BC = amount to add to all affected
				;       VAT Entrys
	ld HL,$FA6C

FixVATLoop:
	ld E,(HL)		;name size byte
	dec HL

	ld D,0

	sbc HL,DE		;HL points to type byte for next var

	ld DE,(VAT_END)
	call CP_HL_DE
        ret Z                   ;exit when VAT is fixed

	dec HL
	ld E,(HL)
	dec HL
	ld D,(HL)		;DE holds address of var
	push HL
        ld HL,(VarAddress2)     ;compare to original address of shrunk var

	ex DE,HL

	push HL
	sbc HL,DE
	pop HL

	ex DE,HL
	pop HL

	jr Z,False
	jp P,True

False:
	ex DE,HL
	add HL,BC
	ex DE,HL		;add DE,BC

True:
	ld (HL),D
	inc HL
	ld (HL),E		;put it back
	dec HL
	dec HL

	jr FixVATLoop

SVATFix:                        ;input: BC = amount to sub from all affected
				;       VAT Entrys
	ld HL,$FA6C

SFixVATLoop:
	ld E,(HL)		;name size byte
	dec HL

	ld D,0

	sbc HL,DE		;HL points to type byte for next var

	ld DE,(VAT_END)
	call CP_HL_DE
        ret Z                   ;exit when VAT is fixed

	dec HL
	ld E,(HL)
	dec HL
	ld D,(HL)		;DE holds address of var
	push HL
        ld HL,(VarAddress)      ;compare to original address of shrunk var
        dec HL

	ex DE,HL

	push HL
	sbc HL,DE
	pop HL

	ex DE,HL
	pop HL

        jr Z,SFalse
        jp P,STrue

SFalse:
	ex DE,HL
        or A
        sbc HL,BC
        ex DE,HL                ;sub DE,BC

STrue:
	ld (HL),D
	inc HL
	ld (HL),E		;put it back
	dec HL
	dec HL

        jr SFixVATLoop



VarAddress:
.dw     0

VarAddress2:
.dw     0

;VATAddress:
;.dw     0

VarLength:
.dw     0

BlockLength:
.dw     0

DEST:
.dw     0

MoveSize:
.dw     0

RelocationArea:

.end


